SET client_encoding = 'UTF8';

-- Function: ol_toch_ins()
-- DROP FUNCTION ol_toch_ins();
CREATE OR REPLACE FUNCTION ol_toch_ins()
  RETURNS trigger AS
$BODY$
DECLARE
  idu INTEGER;
  ngeom geometry;
  idt INTEGER;
  pob SMALLINT;
BEGIN
  idu = NEW.id_uchastok;
  ngeom = NEW.geom;
  pob = NEW.poryadok_obhoda;

  SELECT id FROM msk.tochka WHERE (id_uchastok = idu) AND (public.st_equals(ngeom, geom)) INTO idt;
  IF (idt > 0) THEN
    IF (pob > 0) THEN
      UPDATE msk.tochka SET poryadok_obhoda = pob WHERE id = idt;
    END IF;
    
    RETURN NULL;
  ELSE
    RETURN NEW;
  END IF;  
  
END;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION ol_toch_ins()
  OWNER TO postgres;


-- Function: ol_uch_upd()
-- DROP FUNCTION ol_uch_upd();
CREATE OR REPLACE FUNCTION ol_uch_upd()
  RETURNS trigger AS
$BODY$
DECLARE
  iduch INTEGER;
  idkat CHAR(12);
  nomk SMALLINT;
  geomUch geometry;
BEGIN
  -- если меняется категория земель у многоконтурного, значит меняется категория и у всех контуров
  iduch = NEW.id;
  IF ((OLD.id_kategoriya IS NULL) OR (NEW.id_kategoriya <> OLD.id_kategoriya)) AND (NEW.id_vid_uchastka = '05') THEN
    idkat = NEW.id_kategoriya;
    UPDATE msk.uchastok SET id_kategoriya = idkat 
      WHERE id IN (SELECT id_kontur FROM public.mnogokonturnyy WHERE id_uchastok = iduch);   
  END IF;
  -- если меняется геометрия ЗУ, происходит проверка на наличие точек, прекращающих существование
  IF NOT st_equals(NEW.geom, OLD.geom) THEN
    geomUch = NEW.geom;
    UPDATE msk.tochka SET pre = 1, poryadok_obhoda = 0
      WHERE id_uchastok = iduch AND 
        (st_disjoint(geom, geomUch) OR st_within(geom, geomUch)); 
  END IF;  
  
  NEW.create_user = OLD.create_user;
  NEW.create_date = OLD.create_date;
  NEW.update_user = current_user;
  NEW.update_date = current_timestamp;
  RETURN NEW;
END;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION ol_uch_upd()
  OWNER TO postgres;

-- Update DataBase version information
UPDATE class.database_version SET (number_version, date_version) = (8, '2013-04-24');
